package de.uks.plm.ftglb.incremental.bcgOneQueue;

import x10.compiler.*;

import de.uks.plm.ftglb.incremental.TaskBag;

public final class Bag implements TaskBag
{
    public var data:Rail[Int];

    public def this(val data:Rail[Int]) : Bag
    {
        this.data = data;
    }

    public def this(val size:Long) : Bag
    {
        this.data = new Rail[Int](size);
    }

    @Inline public def merge(val that:TaskBag) : void
    {
        this.merge(that as Bag);
    }

    @Inline public def merge(val that:Bag) : void
    {
        val thisSize = this.size();
        val thatSize = that.size();
        val newSize:Long = thisSize + thatSize;
        val newData:Rail[Int] = new Rail[Int](newSize);
        Rail.copy(this.data, 0, newData, 0, thisSize);
        Rail.copy(that.data, 0, newData, thisSize, thatSize);
        this.data = newData;
    }

    @Inline public def size() : Long
    {
        return (this.data.size);
    }
}
