package de.uks.plm.ftglb.incremental.managers;

import x10.compiler.Inline;
import x10.compiler.Volatile;

import x10.util.ArrayList;
import x10.util.List;
import x10.util.RailUtils;

/**
 * This class manages the states of the local worker. All state-relevant 
 * variable are stored here.
 * 
 * BIG TODO: Clean this mess.
 */
public class StateManager
{
    public static val REDUCER:(Boolean, Boolean) => Boolean
        = (val b1:Boolean, val b2:Boolean) =>
          {
              return (b1 || b2);
          };

    @Volatile transient public var active:Boolean;
    @Volatile transient public var afterMerge:Boolean;
    @Volatile transient public var critical:Boolean;
    @Volatile transient public var emergency:Boolean;
    @Volatile transient public var empty:Boolean;
    @Volatile transient public var ghost:Boolean;
    @Volatile transient public var nextBackupFull:Boolean;
    @Volatile transient public var sendingBackup:Boolean;
    @Volatile transient public var stealFailed:Boolean;
    @Volatile transient public var valid:Boolean;
    @Volatile transient public var waiting:Boolean;
    @Volatile transient public var monitoring:Boolean;
    @Volatile transient public var sendBackupTO:Boolean;
    @Volatile transient public var restoreInProcess:Long;

    // private val c:Rail[Boolean];
    // private val f:Rail[Boolean];
    // private val r:Rail[Boolean];
    // private val v:Rail[Boolean];

    @Inline public def this() : StateManager
    {
        this.active = false;
        this.afterMerge = false;
        this.critical = false;
        this.emergency = false;
        this.empty = true;
        this.ghost = false;
        this.nextBackupFull = false;
        this.sendingBackup = false;
        this.stealFailed = false;
        this.valid = true;
        this.waiting = false;
        this.monitoring = false;
        this.sendBackupTO = false;
        this.restoreInProcess = -1;

        // this.c = new Rail[Boolean](2, false);
        // this.f = new Rail[Boolean](4, false);
        // this.r = new Rail[Boolean](4, false);
        // this.v = new Rail[Boolean](3, false);
    }

    @Inline static def getSetIndices(val rail:Rail[Boolean]) : List[Long]
    {
        val indices:List[Long] = new ArrayList[Long]();

        for (var index:Long = 0; index < rail.size; ++index)
        {
            if(rail(index))
            {
                indices.add(index);
            }
        }

        return (indices);
    }

    @Inline static def setIndex(val index:Long, val rail:Rail[Boolean]) : void
    {
        assert ((-1 < index) && (index < (rail.size + 1)))
               : here + "index must be in [-1, " + rail.size + "].";

        if (-1 < (index - 1))
        {
            rail(index - 1) = false;
        }
        if (index < rail.size)
        {
            rail(index) = true;
        }
    }

    @Inline public def canSendBackup() : Boolean
    {
        return (!(this.sendingBackup || this.emergency));
    }
// 
//     @Inline public def canGive() : Boolean
//     {
//         return (!this.f(0));
//     }
// 
//     @Inline public def checkC(val stage:Long) : Boolean
//     {
//         assert ((-1 < stage) && (stage < (this.c.size + 1)))
//                : here + "stage must be in [0, " + this.c.size + "].";
// 
//         /*
//          * Every place can only report one dead place at a time and has to wait
//          * for the failed place to be recovered before reporting a new, dead
//          * place. Thus, at most one stage is allowed to be set and this must be
//          * the predecessor-stage.
//          */
//         for (index:Long in 0..2)
//         {
//             if ((index + 1 == stage) && !this.c(index))
//             {
//                 return (false);
//             }
//             if ((index + 1 != stage) && this.c(index))
//             {
//                 return (false);
//             }
//         }
//         return (true);
//     }
// 
//     @Inline public def checkF(val stage:Long) : Boolean
//     {
//         /*
//          * stage must be in [0, 4]
//          */
//         assert ((-1 < stage) && (stage < this.f.size + 1))
//                : here + ": stage must be in [0, " + this.f.size + "].";
// 
//         /*
//          * We can only enter stage 0 if we are not in stage 0 and not in 
//          * stage 1.
//          */
//         if (0 == stage)
//         {
//             return (!this.f(0) && !this.f(1));
//         }
//         /*
//          * We can only enter stage 1, if we are in stage 0 and not in stage 1.
//          */
//         if (1 == stage)
//         {
//             return (this.f(0) && !this.f(1));
//         }
//         /*
//          * We can only stage 2, if we are in stage 1.
//          */
//         if (2 == stage)
//         {
//             return (!this.f(0) && this.f(1));
//         }
//         /*
//          * We can only enter stage 3, if we are in stage 2, not in stage 3 and
//          * not in stage 4.
//          */
//         if (3 == stage)
//         {
//             return (this.f(2) && !this.f(3) && !this.f(4));
//         }
//         /*
//          * We can only stage 4 (which means setting stage 3 to "false) if we 
//          * are in stage 3.
//          */
//         // if (4 == stage)
//         return (this.f(3));
//     }
// 
//     @Inline public def checkR(val stage:Long)
//     {
//         assert ((-1 < stage) && (stage < (this.r.size + 1)))
//                : here + "stage must be in [0, " + this.r.size + "].";
// 
//         /*
//          * Every place can only restore one dead place at a time. Thus, at most
//          * one stage is allowed to be set and this must be the
//          * predecessor-stage.
//          */
//         for (index:Long in 0..4)
//         {
//             if ((index + 1 == stage) && !this.v(index))
//             {
//                 return (false);
//             }
//             if ((index + 1 != stage) && this.v(index))
//             {
//                 return (false);
//             }
//         }
//         return (true);
//     }
// 
//     @Inline public def checkV(val stage:Long)
//     {
//         assert ((-1 < stage) && (stage < (this.v.size + 1)))
//                : here + "stage must be in [0, " + this.v.size + "].";
// 
//         /*
//          * We are not allowed to enter two steal-processes as victim at the
//          * same time, at most one state is allowed to be set, and this must be
//          * the predecessor-state.
//          */
//         for (index:Long in 0..(this.v.size - 1))
//         {
//             if ((index + 1 == stage) && !this.v(index))
//             {
//                 return (false);
//             }
//             if ((index + 1 != stage) && this.v(index))
//             {
//                 return (false);
//             }
//         }
//         return (true);
//     }
// 
//     @Inline public def getCStates()
//     {
//         val states:List[Long] = StateManager.getSetIndices(this.c);
//         return (states);
//     }
// 
//     // @Inline public def getFStates()
//     // {
//     //     val states:List[Long] = StateManager.getSetIndices(this.f);
//     //     return (states);
//     // }
// 
//     @Inline public def getRStates()
//     {
//         val states:List[Long] = StateManager.getSetIndices(this.r);
//         return (states);
//     }
// 
//     @Inline public def getVStates()
//     {
//         val states:List[Long] = StateManager.getSetIndices(this.v);
//         return (states);
//     }
// 
//     @Inline public def setC(val stage:Long) : void
//     {
//         // assert (this.checkC(stage))
//         //        : here + ": cannot set C to stage " + stage + ".";
// 
//         StateManager.setIndex(stage, this.c);
//     }
// 
//     @Inline public def setF(val stage:Long) : void
//     {
//         // assert (this.checkF(stage))
//         //        : here + ": Cannot set F to stage " + stage + ".";
// 
//         if (-1 < (stage - 1))
//         {
//             this.f(stage - 1) = false;
//         }
//         if (this.f.size > stage)
//         {
//             this.f(stage) = true;
//         }
//     }
// 
//     @Inline public def setR(val stage:Long) : void
//     {
//         assert (this.checkF(stage))
//                : here + ": Cannot set F to stage " + stage + ".";
// 
//         if (-1 < (stage - 1))
//         {
//             this.r(stage - 1) = false;
//         }
//         if (this.r.size > stage)
//         {
//             this.r(stage) = true;
//         }
//     }
// 
//     @Inline public def setV(val stage:Long) : void
//     {
//         // assert (this.checkV(stage))
//         //        : here + ": Cannot set V to stage " + stage + ".";
// 
//         if (0 < stage)
//         {
//             this.v(stage - 1) = false;
//         }
//         if (2 > stage)
//         {
//             this.v(stage) = true;
//         }
//     }
// 
//     @Inline private def unsetF(val stage:Long) : void
//     {
//         this.f(stage) = false;
//     }
// 
//     @Inline private def unsetC(val stage:Long) : void
//     {
//         this.c(stage) = false;
//     }
// 
//     @Inline private def unsetR(val stage:Long) : void
//     {
//         this.r(stage) = false;
//     }
// 
//     @Inline private def unsetV(val stage:Long) : void
//     {
//         this.v(stage) = false;
//     }
}