package de.uks.plm.ftglb.incremental.utsgOneQueue;

import x10.compiler.*;
import x10.util.Team;
import de.uks.plm.ftglb.incremental.GLBResult;
import de.uks.plm.ftglb.incremental.TaskQueue;
import de.uks.plm.ftglb.incremental.TaskBag;

import de.uks.plm.utils.RingBuffer;

public final class Queue extends UTS implements TaskQueue[Queue, Long]
{
    var result:UTSResult = null;

    public def this(val factor:Int) : Queue
    {
        super(factor);
    }
    
    public def this(val factor:Int, val size:Long) : Queue
    {
        super(factor, size);
    }
    
    public def this(val den:Double, val size:Long) : Queue
    {
        super(den, size);
    }

    @Inline public def process(val n:Long) : Boolean
    {
        var i:Long = 0;
        for (; ((i < n) && (this.size() > 0)); ++i)
        {
            this.expand();
        }
        count += i;
        return (this.size() > 0);
    }

    @Inline public def split() : Bag
    {
        otherHalf:Long = this.size() / 2;
        val myHalf:Long = this.size() - otherHalf;

        if (0 == otherHalf)
        {
            return (null);
        }

        val bag:Bag = new Bag(otherHalf);
        Rail.copy(super.getFromBottom(otherHalf), 0, bag.hash, 0, otherHalf);
        return (bag);
    }

    @Inline public def merge(val bag:Bag) : void
    {
        this.pushBottom(bag.hash);
    }

    @Inline public def merge(val bag:TaskBag) : void
    {
        this.merge(bag as Bag);
    }

    
    @Inline public def mergeAtBottom(val bag:Bag) : void
    {
        this.pushBottom(bag.hash);
    }

    @Inline public def mergeAtBottom (val bag:TaskBag) : void
    {
        this.mergeAtBottom(bag as Bag);
    }

    @Inline public def mergeAtTop(val bag:Bag) : void
    {
        this.mergeAtTop(bag);
    }

    @Inline public def mergeAtTop(val bag:TaskBag) : void
    {
        this.mergeAtTop(bag as Bag);
    }

    // override
    public def printLog() : void {}

    @Inline public def count():Long = count;

    public def getResult() : UTSResult
    {
        val result = new UTSResult();
        return (result);
    }

    public class UTSResult extends GLBResult[Long]
    {
        r:Rail[Long] = new Rail[Long](1l);

        public  def getResult() : Rail[Long]
        {
            r(0) = count;
            return (r);
        }

        public  def getReduceOperator() : Int
        {
            return (Team.ADD);
        }

        public def display(val r:Rail[Long]) : void
        {
            Console.OUT.println("Myresult: "+r(0));
        }
    }

    /** ftglb-extension */

    @Inline public def this(val that:Queue) : Queue
    {
        super(that as UTS);
    }

    @Inline public def clone() : Queue
    {
        return (new Queue(this));
    }

    @Inline public def getTopElement() : Queue
    {
        val q:Queue = new Queue(this.den, 1);
        q.pushTop(this.peekTop());
        q.count = this.count;
        return (q);
    }

    @Inline public def getBottomElement() : Queue
    {
        val q:Queue = new Queue(this.den, 1);
        q.pushTop(this.peekBottom());
        q.count = this.count;
        return (q);
    }

    @Inline public def getQueueFromBottom(val n:Long) : Queue
    {
        val q:Queue = new Queue(this.den, n);
        q.pushTop(super.peekFromBottom(n));
        q.count = this.count;
        return (q);
    }

    @Inline public def getQueueFromTop(val n:Long) : Queue
    {
        val q:Queue = new Queue(this.den, n);
        q.pushTop(super.peekFromTop(n));
        q.count = this.count;
        return (q);
    }

    @Inline public def setResult(val r:GLBResult[Long]) : void
    {
        count = r.getResult()(0);
    }

    @Inline public def setResult(val that:Queue) : void
    {
        count = that.count;
    }

    @Inline public def mergeResult(val that:TaskQueue[Queue, Long]) : void
    {
        assert (that instanceof Queue) // Always false.
               :  here + ": in mergeResult(val that:TaskQueue[Queue, Long]): "
                + "Parameter is not of type Queue!";
    }

    @Inline public def mergeResult(val that:Queue) : void
    {
        count += that.count;
    }

    @Inline public def mergeAtTop(val that:TaskQueue[Queue, Long]) : void
    {
        assert (that instanceof Queue) // Always false.
               :  here + ": in mergAtTop(val that:TaskQueue[Queue, Long]): "
               + "Parameter is not of type Queue!";
    }

    @Inline public def mergeAtTop(val that:Queue) : void
    {
        super.mergeAtTop(that as RingBuffer[TreeNode]);
    }

    @Inline public def mergeAtBottom(val that:TaskQueue[Queue, Long]) : void
    {
        this.mergeAtBottom(that as Queue);
    }

    @Inline public def mergeAtBottom(val that:Queue) : void
    {
        super.mergeAtBottom(that as RingBuffer[TreeNode]);
    }

    @Inline public def removeFromTop(val n:Long) : void
    {
        this.getFromTop(n);
    }

    @Inline public def removeFromBottom(val n:Long) : void
    {
        this.getFromBottom(n);
    }
}